//+------------------------------------------------------------------+
//|                                                   STLM_hist.mq4  |
//|                                       Ramdass - Conversion only  |
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  DarkSlateGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern bool   HistoOnSlope     = false;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "Ftlm Arrows1";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern int    arrowsUpCode     = 241;
extern int    arrowsDnCode     = 242;

double upH[];
double dnH[];
double ftlm[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{ 
   IndicatorBuffers(4);
   SetIndexBuffer(0,upH); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dnH); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ftlm);
   SetIndexBuffer(3,trend); 
   IndicatorShortName("Ftlm");
return(0);
}

int deinit() 
{  
   deleteArrows(); 
   
return(0); 
}

//+------------------------------------------------------------------+
//| STLM                                                             |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
   
   //
   //
   //
   //
   //
   
   for (i=limit; i >= 0; i--)
   {
       double value1 = 
0.4360409450*Close[i+0] 
+0.3658689069*Close[i+1] 
+0.2460452079*Close[i+2] 
+0.1104506886*Close[i+3] 
-0.0054034585*Close[i+4] 
-0.0760367731*Close[i+5] 
-0.0933058722*Close[i+6] 
-0.0670110374*Close[i+7] 
-0.0190795053*Close[i+8] 
+0.0259609206*Close[i+9] 
+0.0502044896*Close[i+10] 
+0.0477818607*Close[i+11] 
+0.0249252327*Close[i+12] 
-0.0047706151*Close[i+13] 
-0.0272432537*Close[i+14] 
-0.0338917071*Close[i+15] 
-0.0244141482*Close[i+16] 
-0.0055774838*Close[i+17] 
+0.0128149838*Close[i+18] 
+0.0226522218*Close[i+19] 
+0.0208778257*Close[i+20] 
+0.0100299086*Close[i+21] 
-0.0036771622*Close[i+22] 
-0.0136744850*Close[i+23] 
-0.0160483392*Close[i+24] 
-0.0108597376*Close[i+25] 
-0.0016060704*Close[i+26] 
+0.0069480557*Close[i+27] 
+0.0110573605*Close[i+28] 
+0.0095711419*Close[i+29] 
+0.0040444064*Close[i+30] 
-0.0023824623*Close[i+31] 
-0.0067093714*Close[i+32] 
-0.0072003400*Close[i+33] 
-0.0047717710*Close[i+34] 
+0.0005541115*Close[i+35] 
+0.0007860160*Close[i+36] 
+0.0130129076*Close[i+37] 
+0.0040364019*Close[i+38]; 

        double value2 = 
-0.0025097319*Close[i+0] 
+0.0513007762*Close[i+1] 
+0.1142800493*Close[i+2] 
+0.1699342860*Close[i+3] 
+0.2025269304*Close[i+4] 
+0.2025269304*Close[i+5] 
+0.1699342860*Close[i+6] 
+0.1142800493*Close[i+7] 
+0.0513007762*Close[i+8] 
-0.0025097319*Close[i+9] 
-0.0353166244*Close[i+10] 
-0.0433375629*Close[i+11] 
-0.0311244617*Close[i+12] 
-0.0088618137*Close[i+13] 
+0.0120580088*Close[i+14] 
+0.0233183633*Close[i+15] 
+0.0221931304*Close[i+16] 
+0.0115769653*Close[i+17] 
-0.0022157966*Close[i+18] 
-0.0126536111*Close[i+19] 
-0.0157416029*Close[i+20] 
-0.0113395830*Close[i+21] 
-0.0025905610*Close[i+22] 
+0.0059521459*Close[i+23] 
+0.0105212252*Close[i+24] 
+0.0096970755*Close[i+25] 
+0.0046585685*Close[i+26] 
-0.0017079230*Close[i+27] 
-0.0063513565*Close[i+28] 
-0.0074539350*Close[i+29] 
-0.0050439973*Close[i+30] 
-0.0007459678*Close[i+31] 
+0.0032271474*Close[i+32] 
+0.0051357867*Close[i+33] 
+0.0044454862*Close[i+34] 
+0.0018784961*Close[i+35] 
-0.0011065767*Close[i+36] 
-0.0031162862*Close[i+37] 
-0.0033443253*Close[i+38] 
-0.0022163335*Close[i+39] 
+0.0002573669*Close[i+40] 
+0.0003650790*Close[i+41] 
+0.0060440751*Close[i+42] 
+0.0018747783*Close[i+43]; 
       
       ftlm[i]  = value1 - value2;
       
       //
       //
       //
       //
       //
       
       upH[i]   = EMPTY_VALUE;
       dnH[i]   = EMPTY_VALUE;
       trend[i] = trend[i+1];
       if(HistoOnSlope)
       {
         if(ftlm[i]>ftlm[i+1]) trend[i] = 1;
         if(ftlm[i]<ftlm[i+1]) trend[i] =-1; 
       }
       else
       {
         if(ftlm[i]>0)         trend[i] = 1;
         if(ftlm[i]<0)         trend[i] =-1;
       } 
       if(trend[i] == 1) upH[i] = ftlm[i];
       if(trend[i] ==-1) dnH[i] = ftlm[i];
       
       //
       //
       //
       //
       //
       
       if (ShowArrows)
       {
          deleteArrow(Time[i]);
          if (trend[i] != trend[i+1])
          {
            if (trend[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
            if (trend[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
          }
       }
               
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int whichBar = 0;
      else      whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("up");
      else  doAlert("down");       
   }   
return(0);
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" FTLM_hist changed trend to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," FTLM_hist " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," FTLM_hist "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}



